#!/usr/bin/env python2
#######################################################
#
#    Winzig's ASCII table
#
#    Copyright (C) 2001,2002 Robert Muth <robert at muth dot org>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; version 2 of June 1991.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program in form of the file COPYING; 
#    if not, write to the 
#
#    Free Software Foundation, Inc. <http://www.fsf.org>
#    59 Temple Place, Suite 330, 
#    Boston, MA 02111-1307  USA
#    $Id: wascii.py,v 1.4 2003/11/30 05:05:03 muth Exp $
#
#######################################################

from __future__ import nested_scopes


import gtk
import pango
import time 
import re 

import wconfig
from wutil import *



GlobalCurrentPage = 0
GlobalPageSize = 256

#######################################################
def RedrawText(widget, label,page):
    global GlobalPageSize
    global GlobalCurrentPage
    
    buffer = widget.get_buffer()

    iter =  buffer.get_start_iter()
    buffer.delete( iter,  buffer.get_end_iter() )


    label.set_markup(" <b>page: 0x%04x</b>" % page)

    buffer.insert_with_tags_by_name(iter,"        01234567 89ABCDEF\n","normal")
    buffer.insert_with_tags_by_name(iter,"-------------------------\n","normal")
    data = ""

    for i in range(GlobalPageSize):
        uchr = i + GlobalCurrentPage 

        if i % 16 == 0: data = data + ("0x%04x: " % uchr)

        if uchr==0 or uchr==8 or uchr==10 or uchr==13: uchr = 32 # convert bad chars to space
 
        data = data + unichr(uchr)
        if i % 16 == 7: data = data + " " # add space
        if i % 16 == 15: data = data + "\n" # line break  

    data = data + "\n"
    buffer.insert_with_tags_by_name(iter,data.encode("utf-8"),"normal")
    return

#######################################################



def CreateWidget():

    vbox = gtk.VBox()
    vbox.show()
    
    hbox = gtk.HBox()
    vbox.pack_start(hbox,0,0)
    hbox.show()

    label = gtk.Label("")
    label.show()

    
    tag_table = gtk.TextTagTable()
    tag_normal = gtk.TextTag("normal")
    tag_normal.set_property("family","monospace")
    tag_normal.set_property("editable",0)
    tag_normal.set_property("weight", pango.WEIGHT_BOLD)
    
    tag_table.add(tag_normal)

    buffer =  gtk.TextBuffer(tag_table)
    text = gtk.TextView(buffer)
    text.show()

    def ActionSwitchMovePage(widget, delta):
        global GlobalPageSize
        global GlobalCurrentPage
        
        page = GlobalCurrentPage + delta
        if page >= 0 and page < 65536:
            GlobalCurrentPage = page
            RedrawText(text,label,page)
        return
        
    button = gtk.Button(" << ")
    hbox.pack_start(button,0,0,0)
    button.connect('clicked', ActionSwitchMovePage, -GlobalPageSize)
    button.show()

    button = gtk.Button(" >> ")
    hbox.pack_start(button,0,0,0)
    button.connect('clicked', ActionSwitchMovePage, +GlobalPageSize)
    button.show()


    hbox.pack_start(label,0,0,0)

    vbox.pack_start(text)


    RedrawText(text,label, 0)
    


    return vbox

#######################################################

#######################################################

if __name__ == '__main__':

   window = gtk.Window()

   def destroy(args):
       window.destroy()
       gtk.mainquit()


   window.connect("destroy", destroy)
   window.set_title('ASCII')
   window.set_border_width(0)
#   window.set_usize(wconfig.win.width, wconfig.win.height)
   widget = CreateWidget()
   window.add(widget)
   window.show()
   gtk.mainloop()

#######################################################
# eof
#######################################################




