#!/usr/bin/env python2

#######################################################
#
#    Winzig
#
#    Copyright (C) 2001,2002 Robert Muth <robert at muth dot org>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; version 2 of June 1991.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program in form of the file COPYING; 
#    if not, write to the 
#
#    Free Software Foundation, Inc. <http://www.fsf.org>
#    59 Temple Place, Suite 330, 
#    Boston, MA 02111-1307  USA
#    $Id: winzig.py,v 1.19 2003/11/30 18:38:44 muth Exp $
#
#######################################################
from __future__ import nested_scopes

import sys
import re
import gtk 

import wabout
import wtodo
import wcalculator
#import wclock
import wascii
import wzettel
import wconfig
import wzettel
import wcontacts
import wcalendar

#######################################################
##
#######################################################
      
def Main():

    geometry_x = -1
    geometry_y = -1
    geometry_w = -1
    geometry_h = -1

    try:
        index = sys.argv.index("-geometry")
        gstring = sys.argv[index+1]
        del sys.argv[index:index+1]
        match = re.compile(r"^(?:(?P<w>[0-9]+)[xX](?P<h>[0-9]+))?" + r"(?:(?P<x>[\+\-][0-9]+)(?P<y>[\+\-][0-9]+))?$").match( gstring )
        if match:
            
            try:
                geometry_w = int(match.group("w"))
            except: 
                geometry_w = -1
            try:
                geometry_h = int(match.group("h"))
            except:
                geometry_h = -1

            try:
                geometry_x = match.group("x")
                if geometry_x[0] == '-':
                    geometry_x = gtk.screen_width() + int(geometry_x)
                else:
                    geometry_x = int(geometry_x)                     
            except:
                geometry_x = -1

            try:
                geometry_y = match.group("y")
                if geometry_y[0] == '-':
                    geometry_y = gtk.screen_height() + int(geometry_y)
                else:
                    geometry_y = int(geometry_y)                     
            except:
                geometry_y = -1

    except:  pass

    tooltips = gtk.Tooltips()
    
    window = gtk.Window()

    def destroy(args):
        window.destroy()
        gtk.mainquit()

    window.connect("destroy", destroy)
    window.set_title('winzig')
#    window.set_border_width(0)

    if geometry_x != -1:
        window.set_uposition( geometry_x, geometry_y)
        
    if geometry_w != -1:
        window.set_usize( geometry_w, geometry_h)
    
    box = gtk.VBox()
    window.add(box)
    box.show()

    
    winzig = gtk.Notebook()
    winzig.set_tab_pos(gtk.POS_TOP)
    box.pack_start(winzig)
    winzig.show()
    
    widget = wcontacts.CreateWidget(tooltips)
    label = gtk.Label("Contacts")
    label.set_padding(2, 2)
    winzig.append_page(widget, label)
    
    widget = wtodo.CreateWidget(tooltips)
    label = gtk.Label("Todo")
    label.set_padding(2, 2)
    winzig.append_page(widget, label)

    widget = wcalculator.CreateWidget(tooltips)
    label = gtk.Label("Calc")
    label.set_padding(2, 2)
    winzig.append_page(widget, label)

    widget = wzettel.CreateWidget(tooltips)
    label = gtk.Label("Notes")
    label.set_padding(2, 2)
    winzig.append_page(widget, label)


#    widget = wclock.CreateWidget(tooltips)
#    label = gtk.Label("Clock")
#    label.set_padding(2, 2)
#    winzig.append_page(widget, label)

    widget = wcalendar.CreateWidget(tooltips)
    label = gtk.Label("Calendar")
    label.set_padding(2, 2)
    winzig.append_page(widget, label)

    widget = wascii.CreateWidget()
    label = gtk.Label("Ascii")
    label.set_padding(2, 2)
    winzig.append_page(widget, label)


    widget = wabout.CreateWidget(tooltips)
    label = gtk.Label("About")
    label.set_padding(2, 2)
    winzig.append_page(widget, label)

    window.show()

    tooltips.enable()


    gtk.mainloop()

#######################################################
##
#######################################################

if __name__ == '__main__':
    Main()

#######################################################
## eof 
#######################################################










